
#include <viz_app.h>
#include <viz_gl.h>

static int trashed= 1;

void trash()
{
    trashed= 1;
}

void paint()
{
    if(trashed==0) return;

    setView();
    loadMap();

    glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);

    glCullFace(GL_BACK);
    glEnable(GL_CULL_FACE);
    glEnable(GL_TEXTURE_2D);
    if(getFiltering())
    {
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_LINEAR);
    }
    else
    {
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
	glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
    }

    if(getDisplayMode())
    {
	glDisable(GL_DEPTH_TEST);
	glPolygonMode(GL_FRONT,GL_LINE);
    }
    else
    {
	glEnable(GL_DEPTH_TEST);
	glPolygonMode(GL_FRONT,GL_FILL);
    }

    paintSphere();

    glDisable(GL_DEPTH_TEST);
    paintPatches();
    glEnable(GL_DEPTH_TEST);

    glDisable(GL_TEXTURE_2D);
    paintSatellites();

    glDisable(GL_DEPTH_TEST);
    glDisable(GL_CULL_FACE);
    paintTrack();
    paintPick();
    paintLastFix();
    paintAuxInfo();
    paintWaypoints();
    paintMapSquare();
    paintCamera();
    paintHelp();
    trashed= 0;
    flush();
}

